// _swi++, call RISC OS SWIs from C++
// Copyright (C) 2008  Timothy Baldwin
// Version 1

// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU Lesser General Public License as published
// by the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.

// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

// http://www.majoroak.f2s.com/tim/RISC_OS/swipp/

// This file is automatically generated - do not edit.

#ifndef _swipp_H
#define _swipp_H

#include <stdint.h>
#include <swis.h>

#if defined(__OPTIMIZE__) && __OPTIMIZE__
#define _SWI_OPTIMIZE 1
#else
#define _SWI_OPTIMIZE 0
#endif

// Define _SWI_USR_MODE for a little better performance in USR 
// mode, at the cost of an incompatability with SVC mode.
#if defined(_SWI_USR_MODE) && _SWI_USR_MODE
#define _SWI_CLOBBERS "memory", "cc"
#else
#define _SWI_CLOBBERS "memory", "cc", "lr"
#endif

namespace _swi_ns {

struct _do_swi_const {
  static void _apply(uint32_t _in_registers, uint32_t _swi_no, int32_t& _p0, int32_t& _p1, int32_t& _p2, int32_t& _p3, int32_t& _p4, int32_t& _p5, int32_t& _p6, int32_t& _p7, int32_t& _p8, int32_t& _p9, uint32_t& _flags) {
    // Must not be a template due to gcc bug:
    // http://gcc.gnu.org/bugzilla/show_bug.cgi?id=33661
    register int32_t _reg0 __asm__("r0");
    if (_in_registers & 0x001) _reg0 = _p0;
    register int32_t _reg1 __asm__("r1");
    if (_in_registers & 0x002) _reg1 = _p1;
    register int32_t _reg2 __asm__("r2");
    if (_in_registers & 0x004) _reg2 = _p2;
    register int32_t _reg3 __asm__("r3");
    if (_in_registers & 0x008) _reg3 = _p3;
    register int32_t _reg4 __asm__("r4");
    if (_in_registers & 0x010) _reg4 = _p4;
    register int32_t _reg5 __asm__("r5");
    if (_in_registers & 0x020) _reg5 = _p5;
    register int32_t _reg6 __asm__("r6");
    if (_in_registers & 0x040) _reg6 = _p6;
    register int32_t _reg7 __asm__("r7");
    if (_in_registers & 0x080) _reg7 = _p7;
    register int32_t _reg8 __asm__("r8");
    if (_in_registers & 0x100) _reg8 = _p8;
    register int32_t _reg9 __asm__("r9");
    if (_in_registers & 0x200) _reg9 = _p9;

    __asm__ volatile ("swi\t%[_swi_n]" : "+r" (_reg0), "+r" (_reg1), "+r" (_reg2), "+r" (_reg3), "+r" (_reg4), "+r" (_reg5), "+r" (_reg6), "+r" (_reg7), "+r" (_reg8), "+r" (_reg9) : [_swi_n] "i" (_swi_no) : _SWI_CLOBBERS);
    _p0 = _reg0;
    _p1 = _reg1;
    _p2 = _reg2;
    _p3 = _reg3;
    _p4 = _reg4;
    _p5 = _reg5;
    _p6 = _reg6;
    _p7 = _reg7;
    _p8 = _reg8;
    _p9 = _reg9;
  }

};

struct _do_swi_var {
  static void _apply(uint32_t _in_registers, uint32_t _swi_no, int32_t& _p0, int32_t& _p1, int32_t& _p2, int32_t& _p3, int32_t& _p4, int32_t& _p5, int32_t& _p6, int32_t& _p7, int32_t& _p8, int32_t& _p9, uint32_t& _flags) {
    // Must not be a template due to gcc bug:
    // http://gcc.gnu.org/bugzilla/show_bug.cgi?id=33661
    register int32_t _reg0 __asm__("r0");
    if (_in_registers & 0x001) _reg0 = _p0;
    register int32_t _reg1 __asm__("r1");
    if (_in_registers & 0x002) _reg1 = _p1;
    register int32_t _reg2 __asm__("r2");
    if (_in_registers & 0x004) _reg2 = _p2;
    register int32_t _reg3 __asm__("r3");
    if (_in_registers & 0x008) _reg3 = _p3;
    register int32_t _reg4 __asm__("r4");
    if (_in_registers & 0x010) _reg4 = _p4;
    register int32_t _reg5 __asm__("r5");
    if (_in_registers & 0x020) _reg5 = _p5;
    register int32_t _reg6 __asm__("r6");
    if (_in_registers & 0x040) _reg6 = _p6;
    register int32_t _reg7 __asm__("r7");
    if (_in_registers & 0x080) _reg7 = _p7;
    register int32_t _reg8 __asm__("r8");
    if (_in_registers & 0x100) _reg8 = _p8;
    register int32_t _reg9 __asm__("r9");
    if (_in_registers & 0x200) _reg9 = _p9;

    register uint32_t _reg12 __asm__("r12") = _swi_no;
    __asm__ volatile ("swi\t0x71" : "+r" (_reg0), "+r" (_reg1), "+r" (_reg2), "+r" (_reg3), "+r" (_reg4), "+r" (_reg5), "+r" (_reg6), "+r" (_reg7), "+r" (_reg8), "+r" (_reg9) : "r" (_reg12) : _SWI_CLOBBERS);
    _p0 = _reg0;
    _p1 = _reg1;
    _p2 = _reg2;
    _p3 = _reg3;
    _p4 = _reg4;
    _p5 = _reg5;
    _p6 = _reg6;
    _p7 = _reg7;
    _p8 = _reg8;
    _p9 = _reg9;
  }

};

struct _do_swi_const_flags {
  static void _apply(uint32_t _in_registers, uint32_t _swi_no, int32_t& _p0, int32_t& _p1, int32_t& _p2, int32_t& _p3, int32_t& _p4, int32_t& _p5, int32_t& _p6, int32_t& _p7, int32_t& _p8, int32_t& _p9, uint32_t& _flags) {
    // Must not be a template due to gcc bug:
    // http://gcc.gnu.org/bugzilla/show_bug.cgi?id=33661
    register int32_t _reg0 __asm__("r0");
    if (_in_registers & 0x001) _reg0 = _p0;
    register int32_t _reg1 __asm__("r1");
    if (_in_registers & 0x002) _reg1 = _p1;
    register int32_t _reg2 __asm__("r2");
    if (_in_registers & 0x004) _reg2 = _p2;
    register int32_t _reg3 __asm__("r3");
    if (_in_registers & 0x008) _reg3 = _p3;
    register int32_t _reg4 __asm__("r4");
    if (_in_registers & 0x010) _reg4 = _p4;
    register int32_t _reg5 __asm__("r5");
    if (_in_registers & 0x020) _reg5 = _p5;
    register int32_t _reg6 __asm__("r6");
    if (_in_registers & 0x040) _reg6 = _p6;
    register int32_t _reg7 __asm__("r7");
    if (_in_registers & 0x080) _reg7 = _p7;
    register int32_t _reg8 __asm__("r8");
    if (_in_registers & 0x100) _reg8 = _p8;
    register int32_t _reg9 __asm__("r9");
    if (_in_registers & 0x200) _reg9 = _p9;

    __asm__ volatile ("swi\t%[_swi_n]\n\teor\t%[_cpsr], r15, r15\n\tmsr\t%[_cpsr], cpsr" : "+r" (_reg0), "+r" (_reg1), "+r" (_reg2), "+r" (_reg3), "+r" (_reg4), "+r" (_reg5), "+r" (_reg6), "+r" (_reg7), "+r" (_reg8), "+r" (_reg9), [_cpsr] "=r" (_flags) : [_swi_n] "i" (_swi_no) : _SWI_CLOBBERS);
    _p0 = _reg0;
    _p1 = _reg1;
    _p2 = _reg2;
    _p3 = _reg3;
    _p4 = _reg4;
    _p5 = _reg5;
    _p6 = _reg6;
    _p7 = _reg7;
    _p8 = _reg8;
    _p9 = _reg9;
  }

};

struct _do_swi_var_flags {
  static void _apply(uint32_t _in_registers, uint32_t _swi_no, int32_t& _p0, int32_t& _p1, int32_t& _p2, int32_t& _p3, int32_t& _p4, int32_t& _p5, int32_t& _p6, int32_t& _p7, int32_t& _p8, int32_t& _p9, uint32_t& _flags) {
    // Must not be a template due to gcc bug:
    // http://gcc.gnu.org/bugzilla/show_bug.cgi?id=33661
    register int32_t _reg0 __asm__("r0");
    if (_in_registers & 0x001) _reg0 = _p0;
    register int32_t _reg1 __asm__("r1");
    if (_in_registers & 0x002) _reg1 = _p1;
    register int32_t _reg2 __asm__("r2");
    if (_in_registers & 0x004) _reg2 = _p2;
    register int32_t _reg3 __asm__("r3");
    if (_in_registers & 0x008) _reg3 = _p3;
    register int32_t _reg4 __asm__("r4");
    if (_in_registers & 0x010) _reg4 = _p4;
    register int32_t _reg5 __asm__("r5");
    if (_in_registers & 0x020) _reg5 = _p5;
    register int32_t _reg6 __asm__("r6");
    if (_in_registers & 0x040) _reg6 = _p6;
    register int32_t _reg7 __asm__("r7");
    if (_in_registers & 0x080) _reg7 = _p7;
    register int32_t _reg8 __asm__("r8");
    if (_in_registers & 0x100) _reg8 = _p8;
    register int32_t _reg9 __asm__("r9");
    if (_in_registers & 0x200) _reg9 = _p9;

    register uint32_t _reg12 __asm__("r12") = _swi_no;
    __asm__ volatile ("swi\t0x71\n\teor\t%[_cpsr], r15, r15\n\tmsr\t%[_cpsr], cpsr" : "+r" (_reg0), "+r" (_reg1), "+r" (_reg2), "+r" (_reg3), "+r" (_reg4), "+r" (_reg5), "+r" (_reg6), "+r" (_reg7), "+r" (_reg8), "+r" (_reg9), [_cpsr] "=r" (_flags) : "r" (_reg12) : _SWI_CLOBBERS);
    _p0 = _reg0;
    _p1 = _reg1;
    _p2 = _reg2;
    _p3 = _reg3;
    _p4 = _reg4;
    _p5 = _reg5;
    _p6 = _reg6;
    _p7 = _reg7;
    _p8 = _reg8;
    _p9 = _reg9;
  }

};

#undef _SWI_CLOBBERS

template <bool _is_const, bool _need_flags> struct _do_swi_select {};

template <> struct _do_swi_select<false, false> {
  typedef _do_swi_var _do_swi;
};

template <> struct _do_swi_select<true, false> {
  typedef _do_swi_const _do_swi;
};

template <> struct _do_swi_select<false, true> {
  typedef _do_swi_var_flags _do_swi;
};

template <> struct _do_swi_select<true, true> {
  typedef _do_swi_const_flags _do_swi;
};


// Recursive compile-time bit count.
template <unsigned _p> struct _popcount {
  static const unsigned _result = (_p & 1) + _popcount<(_p >> 1)>::_result;
};

template <> struct _popcount<0> {
  static const unsigned _result = 0;
};

struct _null_type { 
  int _dummy[0]; 
  template <typename _t> void operator = (_t const & _dummy) {}
};





template <bool _bool_value> struct _if {
  typedef int32_t _return_type;
  template <typename _t> static int32_t _val(_t _v) { return 0; }
  template <typename _t> static void _set(_t const &_v, int32_t _r) {}
  template <typename _t> static void _set_block(char *_ptr, _t const & _val) {}
};

template <> struct _if<true> {
  typedef _kernel_oserror* _return_type;

  // Write an _OUT() parameter.
  template <typename _t> static void _set(_t const & _v, uint32_t _r) { *_v = _r; }

  // Refuse to handle _null_type, long long, and unsigned long long as _IN() parameters.
  static _null_type _val(_null_type _v) { return _null_type(); }
  static _null_type _val(long long _v) { return _null_type(); }
  static _null_type _val(unsigned long long _v) { return _null_type(); }

  // Generic reading of _IN() parameters.
  template <typename _t> static int32_t _val(_t * _v) { return (uint32_t)_v; }
  template <typename _t> static int32_t _val(_t const * _v) { return (uint32_t)_v; }
  template <typename _t> static int32_t _val(_t const & _v) { return static_cast<int32_t>(_v); }

  // Ignore _null_type _BLOCK() parameters.
  static void _set_block(char *_ptr, _null_type const & _val) {}

  // Generic handling of _BLOCK() parameters.
  template <typename _t> static void _set_block(char *_ptr, _t const & _val) { *( _t *)_ptr = _val; }

  // Including arrays.
  template <typename _t> static void _set_block(char *_ptr, _t const _val[]) { *( _t const **)_ptr = _val; }

  // Special cases for built-in types.
  static void _set_block(char *_ptr, char _val) { *(int32_t *)_ptr = _val; }
  static void _set_block(char *_ptr, signed char _val) { *(int32_t *)_ptr = _val; }
  static void _set_block(char *_ptr, unsigned char _val) { *(int32_t *)_ptr = _val; }
  static void _set_block(char *_ptr, short _val) { *(int32_t *)_ptr = _val; }
  static void _set_block(char *_ptr, unsigned short _val) { *(int32_t *)_ptr = _val; }
  static void _set_block(char *_ptr, int _val) { *(int32_t *)_ptr = _val; }
  static void _set_block(char *_ptr, unsigned int _val) { *(uint32_t *)_ptr = _val; }

  // This seems to cause GCC to run out of registers. Why?
  static void _set_block(char *_ptr, long long _val) { *(int64_t *)_ptr = _val; }
  static void _set_block(char *_ptr, unsigned long long _val) { *(uint64_t *)_ptr = _val; }

};

// Generic handling of _BLOCK() parameters.
template <typename _t> struct _sizeof {
  static unsigned const _result = (sizeof(_t) + 3U) & ~3U;
};

// Including arrays.
template <typename _t> struct _sizeof<_t []> { static unsigned const _result = 4; };
template <typename _t> struct _sizeof<_t const []> { static unsigned const _result = 4; };

// Ignore _null_type _BLOCK() parameters.
template <> struct _sizeof<_null_type> { static unsigned const _result = 0; };

// Special cases for long long.
template <> struct _sizeof<long long> { static unsigned const _result = 8; };
template <> struct _sizeof<unsigned long long> { static unsigned const _result = 8; };


// Return the n-th argument.
template <unsigned _n> struct _select {};

template <> struct _select<0> { template <typename _0t, typename _1t, typename _2t, typename _3t, typename _4t, typename _5t, typename _6t, typename _7t, typename _8t, typename _9t, typename _10t, typename _11t, typename _12t, typename _13t, typename _14t, typename _15t, typename _16t, typename _17t, typename _18t, typename _19t, typename _20t> static _0t _apply(_0t _0, _1t _1, _2t _2, _3t _3, _4t _4, _5t _5, _6t _6, _7t _7, _8t _8, _9t _9, _10t _10, _11t _11, _12t _12, _13t _13, _14t _14, _15t _15, _16t _16, _17t _17, _18t _18, _19t _19, _20t _20) { return _0; } };

template <> struct _select<1> { template <typename _0t, typename _1t, typename _2t, typename _3t, typename _4t, typename _5t, typename _6t, typename _7t, typename _8t, typename _9t, typename _10t, typename _11t, typename _12t, typename _13t, typename _14t, typename _15t, typename _16t, typename _17t, typename _18t, typename _19t, typename _20t> static _1t _apply(_0t _0, _1t _1, _2t _2, _3t _3, _4t _4, _5t _5, _6t _6, _7t _7, _8t _8, _9t _9, _10t _10, _11t _11, _12t _12, _13t _13, _14t _14, _15t _15, _16t _16, _17t _17, _18t _18, _19t _19, _20t _20) { return _1; } };

template <> struct _select<2> { template <typename _0t, typename _1t, typename _2t, typename _3t, typename _4t, typename _5t, typename _6t, typename _7t, typename _8t, typename _9t, typename _10t, typename _11t, typename _12t, typename _13t, typename _14t, typename _15t, typename _16t, typename _17t, typename _18t, typename _19t, typename _20t> static _2t _apply(_0t _0, _1t _1, _2t _2, _3t _3, _4t _4, _5t _5, _6t _6, _7t _7, _8t _8, _9t _9, _10t _10, _11t _11, _12t _12, _13t _13, _14t _14, _15t _15, _16t _16, _17t _17, _18t _18, _19t _19, _20t _20) { return _2; } };

template <> struct _select<3> { template <typename _0t, typename _1t, typename _2t, typename _3t, typename _4t, typename _5t, typename _6t, typename _7t, typename _8t, typename _9t, typename _10t, typename _11t, typename _12t, typename _13t, typename _14t, typename _15t, typename _16t, typename _17t, typename _18t, typename _19t, typename _20t> static _3t _apply(_0t _0, _1t _1, _2t _2, _3t _3, _4t _4, _5t _5, _6t _6, _7t _7, _8t _8, _9t _9, _10t _10, _11t _11, _12t _12, _13t _13, _14t _14, _15t _15, _16t _16, _17t _17, _18t _18, _19t _19, _20t _20) { return _3; } };

template <> struct _select<4> { template <typename _0t, typename _1t, typename _2t, typename _3t, typename _4t, typename _5t, typename _6t, typename _7t, typename _8t, typename _9t, typename _10t, typename _11t, typename _12t, typename _13t, typename _14t, typename _15t, typename _16t, typename _17t, typename _18t, typename _19t, typename _20t> static _4t _apply(_0t _0, _1t _1, _2t _2, _3t _3, _4t _4, _5t _5, _6t _6, _7t _7, _8t _8, _9t _9, _10t _10, _11t _11, _12t _12, _13t _13, _14t _14, _15t _15, _16t _16, _17t _17, _18t _18, _19t _19, _20t _20) { return _4; } };

template <> struct _select<5> { template <typename _0t, typename _1t, typename _2t, typename _3t, typename _4t, typename _5t, typename _6t, typename _7t, typename _8t, typename _9t, typename _10t, typename _11t, typename _12t, typename _13t, typename _14t, typename _15t, typename _16t, typename _17t, typename _18t, typename _19t, typename _20t> static _5t _apply(_0t _0, _1t _1, _2t _2, _3t _3, _4t _4, _5t _5, _6t _6, _7t _7, _8t _8, _9t _9, _10t _10, _11t _11, _12t _12, _13t _13, _14t _14, _15t _15, _16t _16, _17t _17, _18t _18, _19t _19, _20t _20) { return _5; } };

template <> struct _select<6> { template <typename _0t, typename _1t, typename _2t, typename _3t, typename _4t, typename _5t, typename _6t, typename _7t, typename _8t, typename _9t, typename _10t, typename _11t, typename _12t, typename _13t, typename _14t, typename _15t, typename _16t, typename _17t, typename _18t, typename _19t, typename _20t> static _6t _apply(_0t _0, _1t _1, _2t _2, _3t _3, _4t _4, _5t _5, _6t _6, _7t _7, _8t _8, _9t _9, _10t _10, _11t _11, _12t _12, _13t _13, _14t _14, _15t _15, _16t _16, _17t _17, _18t _18, _19t _19, _20t _20) { return _6; } };

template <> struct _select<7> { template <typename _0t, typename _1t, typename _2t, typename _3t, typename _4t, typename _5t, typename _6t, typename _7t, typename _8t, typename _9t, typename _10t, typename _11t, typename _12t, typename _13t, typename _14t, typename _15t, typename _16t, typename _17t, typename _18t, typename _19t, typename _20t> static _7t _apply(_0t _0, _1t _1, _2t _2, _3t _3, _4t _4, _5t _5, _6t _6, _7t _7, _8t _8, _9t _9, _10t _10, _11t _11, _12t _12, _13t _13, _14t _14, _15t _15, _16t _16, _17t _17, _18t _18, _19t _19, _20t _20) { return _7; } };

template <> struct _select<8> { template <typename _0t, typename _1t, typename _2t, typename _3t, typename _4t, typename _5t, typename _6t, typename _7t, typename _8t, typename _9t, typename _10t, typename _11t, typename _12t, typename _13t, typename _14t, typename _15t, typename _16t, typename _17t, typename _18t, typename _19t, typename _20t> static _8t _apply(_0t _0, _1t _1, _2t _2, _3t _3, _4t _4, _5t _5, _6t _6, _7t _7, _8t _8, _9t _9, _10t _10, _11t _11, _12t _12, _13t _13, _14t _14, _15t _15, _16t _16, _17t _17, _18t _18, _19t _19, _20t _20) { return _8; } };

template <> struct _select<9> { template <typename _0t, typename _1t, typename _2t, typename _3t, typename _4t, typename _5t, typename _6t, typename _7t, typename _8t, typename _9t, typename _10t, typename _11t, typename _12t, typename _13t, typename _14t, typename _15t, typename _16t, typename _17t, typename _18t, typename _19t, typename _20t> static _9t _apply(_0t _0, _1t _1, _2t _2, _3t _3, _4t _4, _5t _5, _6t _6, _7t _7, _8t _8, _9t _9, _10t _10, _11t _11, _12t _12, _13t _13, _14t _14, _15t _15, _16t _16, _17t _17, _18t _18, _19t _19, _20t _20) { return _9; } };

template <> struct _select<10> { template <typename _0t, typename _1t, typename _2t, typename _3t, typename _4t, typename _5t, typename _6t, typename _7t, typename _8t, typename _9t, typename _10t, typename _11t, typename _12t, typename _13t, typename _14t, typename _15t, typename _16t, typename _17t, typename _18t, typename _19t, typename _20t> static _10t _apply(_0t _0, _1t _1, _2t _2, _3t _3, _4t _4, _5t _5, _6t _6, _7t _7, _8t _8, _9t _9, _10t _10, _11t _11, _12t _12, _13t _13, _14t _14, _15t _15, _16t _16, _17t _17, _18t _18, _19t _19, _20t _20) { return _10; } };

template <> struct _select<11> { template <typename _0t, typename _1t, typename _2t, typename _3t, typename _4t, typename _5t, typename _6t, typename _7t, typename _8t, typename _9t, typename _10t, typename _11t, typename _12t, typename _13t, typename _14t, typename _15t, typename _16t, typename _17t, typename _18t, typename _19t, typename _20t> static _11t _apply(_0t _0, _1t _1, _2t _2, _3t _3, _4t _4, _5t _5, _6t _6, _7t _7, _8t _8, _9t _9, _10t _10, _11t _11, _12t _12, _13t _13, _14t _14, _15t _15, _16t _16, _17t _17, _18t _18, _19t _19, _20t _20) { return _11; } };

template <> struct _select<12> { template <typename _0t, typename _1t, typename _2t, typename _3t, typename _4t, typename _5t, typename _6t, typename _7t, typename _8t, typename _9t, typename _10t, typename _11t, typename _12t, typename _13t, typename _14t, typename _15t, typename _16t, typename _17t, typename _18t, typename _19t, typename _20t> static _12t _apply(_0t _0, _1t _1, _2t _2, _3t _3, _4t _4, _5t _5, _6t _6, _7t _7, _8t _8, _9t _9, _10t _10, _11t _11, _12t _12, _13t _13, _14t _14, _15t _15, _16t _16, _17t _17, _18t _18, _19t _19, _20t _20) { return _12; } };

template <> struct _select<13> { template <typename _0t, typename _1t, typename _2t, typename _3t, typename _4t, typename _5t, typename _6t, typename _7t, typename _8t, typename _9t, typename _10t, typename _11t, typename _12t, typename _13t, typename _14t, typename _15t, typename _16t, typename _17t, typename _18t, typename _19t, typename _20t> static _13t _apply(_0t _0, _1t _1, _2t _2, _3t _3, _4t _4, _5t _5, _6t _6, _7t _7, _8t _8, _9t _9, _10t _10, _11t _11, _12t _12, _13t _13, _14t _14, _15t _15, _16t _16, _17t _17, _18t _18, _19t _19, _20t _20) { return _13; } };

template <> struct _select<14> { template <typename _0t, typename _1t, typename _2t, typename _3t, typename _4t, typename _5t, typename _6t, typename _7t, typename _8t, typename _9t, typename _10t, typename _11t, typename _12t, typename _13t, typename _14t, typename _15t, typename _16t, typename _17t, typename _18t, typename _19t, typename _20t> static _14t _apply(_0t _0, _1t _1, _2t _2, _3t _3, _4t _4, _5t _5, _6t _6, _7t _7, _8t _8, _9t _9, _10t _10, _11t _11, _12t _12, _13t _13, _14t _14, _15t _15, _16t _16, _17t _17, _18t _18, _19t _19, _20t _20) { return _14; } };

template <> struct _select<15> { template <typename _0t, typename _1t, typename _2t, typename _3t, typename _4t, typename _5t, typename _6t, typename _7t, typename _8t, typename _9t, typename _10t, typename _11t, typename _12t, typename _13t, typename _14t, typename _15t, typename _16t, typename _17t, typename _18t, typename _19t, typename _20t> static _15t _apply(_0t _0, _1t _1, _2t _2, _3t _3, _4t _4, _5t _5, _6t _6, _7t _7, _8t _8, _9t _9, _10t _10, _11t _11, _12t _12, _13t _13, _14t _14, _15t _15, _16t _16, _17t _17, _18t _18, _19t _19, _20t _20) { return _15; } };

template <> struct _select<16> { template <typename _0t, typename _1t, typename _2t, typename _3t, typename _4t, typename _5t, typename _6t, typename _7t, typename _8t, typename _9t, typename _10t, typename _11t, typename _12t, typename _13t, typename _14t, typename _15t, typename _16t, typename _17t, typename _18t, typename _19t, typename _20t> static _16t _apply(_0t _0, _1t _1, _2t _2, _3t _3, _4t _4, _5t _5, _6t _6, _7t _7, _8t _8, _9t _9, _10t _10, _11t _11, _12t _12, _13t _13, _14t _14, _15t _15, _16t _16, _17t _17, _18t _18, _19t _19, _20t _20) { return _16; } };

template <> struct _select<17> { template <typename _0t, typename _1t, typename _2t, typename _3t, typename _4t, typename _5t, typename _6t, typename _7t, typename _8t, typename _9t, typename _10t, typename _11t, typename _12t, typename _13t, typename _14t, typename _15t, typename _16t, typename _17t, typename _18t, typename _19t, typename _20t> static _17t _apply(_0t _0, _1t _1, _2t _2, _3t _3, _4t _4, _5t _5, _6t _6, _7t _7, _8t _8, _9t _9, _10t _10, _11t _11, _12t _12, _13t _13, _14t _14, _15t _15, _16t _16, _17t _17, _18t _18, _19t _19, _20t _20) { return _17; } };

template <> struct _select<18> { template <typename _0t, typename _1t, typename _2t, typename _3t, typename _4t, typename _5t, typename _6t, typename _7t, typename _8t, typename _9t, typename _10t, typename _11t, typename _12t, typename _13t, typename _14t, typename _15t, typename _16t, typename _17t, typename _18t, typename _19t, typename _20t> static _18t _apply(_0t _0, _1t _1, _2t _2, _3t _3, _4t _4, _5t _5, _6t _6, _7t _7, _8t _8, _9t _9, _10t _10, _11t _11, _12t _12, _13t _13, _14t _14, _15t _15, _16t _16, _17t _17, _18t _18, _19t _19, _20t _20) { return _18; } };

template <> struct _select<19> { template <typename _0t, typename _1t, typename _2t, typename _3t, typename _4t, typename _5t, typename _6t, typename _7t, typename _8t, typename _9t, typename _10t, typename _11t, typename _12t, typename _13t, typename _14t, typename _15t, typename _16t, typename _17t, typename _18t, typename _19t, typename _20t> static _19t _apply(_0t _0, _1t _1, _2t _2, _3t _3, _4t _4, _5t _5, _6t _6, _7t _7, _8t _8, _9t _9, _10t _10, _11t _11, _12t _12, _13t _13, _14t _14, _15t _15, _16t _16, _17t _17, _18t _18, _19t _19, _20t _20) { return _19; } };

template <> struct _select<20> { template <typename _0t, typename _1t, typename _2t, typename _3t, typename _4t, typename _5t, typename _6t, typename _7t, typename _8t, typename _9t, typename _10t, typename _11t, typename _12t, typename _13t, typename _14t, typename _15t, typename _16t, typename _17t, typename _18t, typename _19t, typename _20t> static _20t _apply(_0t _0, _1t _1, _2t _2, _3t _3, _4t _4, _5t _5, _6t _6, _7t _7, _8t _8, _9t _9, _10t _10, _11t _11, _12t _12, _13t _13, _14t _14, _15t _15, _16t _16, _17t _17, _18t _18, _19t _19, _20t _20) { return _20; } };

template <bool _is_const, bool _is_x, uint32_t _args> struct _imp {
  typedef typename _if<_is_x>::_return_type _return_type;
  typedef typename _do_swi_select<_is_const, _is_x || ((_args >> 21) > 9) || (_args & (1 << 21)) >::_do_swi _do_swi;

  template <typename _0t, typename _1t, typename _2t, typename _3t, typename _4t, typename _5t, typename _6t, typename _7t, typename _8t, typename _9t, typename _10t, typename _11t, typename _12t, typename _13t, typename _14t, typename _15t, typename _16t, typename _17t, typename _18t, typename _19t, typename _20t, typename _21t, typename _22t, typename _23t, typename _24t, typename _25t, typename _26t, typename _27t, typename _28t, typename _29t> static _return_type _apply2(uint32_t _swi_no, _0t const& _0, _1t const& _1, _2t const& _2, _3t const& _3, _4t const& _4, _5t const& _5, _6t const& _6, _7t const& _7, _8t const& _8, _9t const& _9, _10t const& _10, _11t const& _11, _12t const& _12, _13t const& _13, _14t const& _14, _15t const& _15, _16t const& _16, _17t const& _17, _18t const& _18, _19t const& _19, _20t const& _20, _21t const& _21, _22t const& _22, _23t const& _23, _24t const& _24, _25t const& _25, _26t const& _26, _27t const& _27, _28t const& _28, _29t const& _29) {
    int const _block = _popcount<_args & 0xFE00003F>::_result;
    char _array[0
     + (0 >= _block ? _sizeof<_0t>::_result : 0)
     + (1 >= _block ? _sizeof<_1t>::_result : 0)
     + (2 >= _block ? _sizeof<_2t>::_result : 0)
     + (3 >= _block ? _sizeof<_3t>::_result : 0)
     + (4 >= _block ? _sizeof<_4t>::_result : 0)
     + (5 >= _block ? _sizeof<_5t>::_result : 0)
     + (6 >= _block ? _sizeof<_6t>::_result : 0)
     + (7 >= _block ? _sizeof<_7t>::_result : 0)
     + (8 >= _block ? _sizeof<_8t>::_result : 0)
     + (9 >= _block ? _sizeof<_9t>::_result : 0)
     + (10 >= _block ? _sizeof<_10t>::_result : 0)
     + (11 >= _block ? _sizeof<_11t>::_result : 0)
     + (12 >= _block ? _sizeof<_12t>::_result : 0)
     + (13 >= _block ? _sizeof<_13t>::_result : 0)
     + (14 >= _block ? _sizeof<_14t>::_result : 0)
     + (15 >= _block ? _sizeof<_15t>::_result : 0)
     + (16 >= _block ? _sizeof<_16t>::_result : 0)
     + (17 >= _block ? _sizeof<_17t>::_result : 0)
     + (18 >= _block ? _sizeof<_18t>::_result : 0)
     + (19 >= _block ? _sizeof<_19t>::_result : 0)
     + (20 >= _block ? _sizeof<_20t>::_result : 0)
     + (21 >= _block ? _sizeof<_21t>::_result : 0)
     + (22 >= _block ? _sizeof<_22t>::_result : 0)
     + (23 >= _block ? _sizeof<_23t>::_result : 0)
     + (24 >= _block ? _sizeof<_24t>::_result : 0)
     + (25 >= _block ? _sizeof<_25t>::_result : 0)
     + (26 >= _block ? _sizeof<_26t>::_result : 0)
     + (27 >= _block ? _sizeof<_27t>::_result : 0)
     + (28 >= _block ? _sizeof<_28t>::_result : 0)
     + (29 >= _block ? _sizeof<_29t>::_result : 0)
    ] __attribute__((__aligned__(4)));
    if (_args & (1U << 11)) {
      char *_ptr2 = _array;
      _if<0 >= _block>::_set_block(_ptr2, _0);
      _ptr2 += (0 >= _block ? _sizeof<_0t>::_result : 0);
      _if<1 >= _block>::_set_block(_ptr2, _1);
      _ptr2 += (1 >= _block ? _sizeof<_1t>::_result : 0);
      _if<2 >= _block>::_set_block(_ptr2, _2);
      _ptr2 += (2 >= _block ? _sizeof<_2t>::_result : 0);
      _if<3 >= _block>::_set_block(_ptr2, _3);
      _ptr2 += (3 >= _block ? _sizeof<_3t>::_result : 0);
      _if<4 >= _block>::_set_block(_ptr2, _4);
      _ptr2 += (4 >= _block ? _sizeof<_4t>::_result : 0);
      _if<5 >= _block>::_set_block(_ptr2, _5);
      _ptr2 += (5 >= _block ? _sizeof<_5t>::_result : 0);
      _if<6 >= _block>::_set_block(_ptr2, _6);
      _ptr2 += (6 >= _block ? _sizeof<_6t>::_result : 0);
      _if<7 >= _block>::_set_block(_ptr2, _7);
      _ptr2 += (7 >= _block ? _sizeof<_7t>::_result : 0);
      _if<8 >= _block>::_set_block(_ptr2, _8);
      _ptr2 += (8 >= _block ? _sizeof<_8t>::_result : 0);
      _if<9 >= _block>::_set_block(_ptr2, _9);
      _ptr2 += (9 >= _block ? _sizeof<_9t>::_result : 0);
      _if<10 >= _block>::_set_block(_ptr2, _10);
      _ptr2 += (10 >= _block ? _sizeof<_10t>::_result : 0);
      _if<11 >= _block>::_set_block(_ptr2, _11);
      _ptr2 += (11 >= _block ? _sizeof<_11t>::_result : 0);
      _if<12 >= _block>::_set_block(_ptr2, _12);
      _ptr2 += (12 >= _block ? _sizeof<_12t>::_result : 0);
      _if<13 >= _block>::_set_block(_ptr2, _13);
      _ptr2 += (13 >= _block ? _sizeof<_13t>::_result : 0);
      _if<14 >= _block>::_set_block(_ptr2, _14);
      _ptr2 += (14 >= _block ? _sizeof<_14t>::_result : 0);
      _if<15 >= _block>::_set_block(_ptr2, _15);
      _ptr2 += (15 >= _block ? _sizeof<_15t>::_result : 0);
      _if<16 >= _block>::_set_block(_ptr2, _16);
      _ptr2 += (16 >= _block ? _sizeof<_16t>::_result : 0);
      _if<17 >= _block>::_set_block(_ptr2, _17);
      _ptr2 += (17 >= _block ? _sizeof<_17t>::_result : 0);
      _if<18 >= _block>::_set_block(_ptr2, _18);
      _ptr2 += (18 >= _block ? _sizeof<_18t>::_result : 0);
      _if<19 >= _block>::_set_block(_ptr2, _19);
      _ptr2 += (19 >= _block ? _sizeof<_19t>::_result : 0);
      _if<20 >= _block>::_set_block(_ptr2, _20);
      _ptr2 += (20 >= _block ? _sizeof<_20t>::_result : 0);
      _if<21 >= _block>::_set_block(_ptr2, _21);
      _ptr2 += (21 >= _block ? _sizeof<_21t>::_result : 0);
      _if<22 >= _block>::_set_block(_ptr2, _22);
      _ptr2 += (22 >= _block ? _sizeof<_22t>::_result : 0);
      _if<23 >= _block>::_set_block(_ptr2, _23);
      _ptr2 += (23 >= _block ? _sizeof<_23t>::_result : 0);
      _if<24 >= _block>::_set_block(_ptr2, _24);
      _ptr2 += (24 >= _block ? _sizeof<_24t>::_result : 0);
      _if<25 >= _block>::_set_block(_ptr2, _25);
      _ptr2 += (25 >= _block ? _sizeof<_25t>::_result : 0);
      _if<26 >= _block>::_set_block(_ptr2, _26);
      _ptr2 += (26 >= _block ? _sizeof<_26t>::_result : 0);
      _if<27 >= _block>::_set_block(_ptr2, _27);
      _ptr2 += (27 >= _block ? _sizeof<_27t>::_result : 0);
      _if<28 >= _block>::_set_block(_ptr2, _28);
      _ptr2 += (28 >= _block ? _sizeof<_28t>::_result : 0);
      _if<29 >= _block>::_set_block(_ptr2, _29);
      _ptr2 += (29 >= _block ? _sizeof<_29t>::_result : 0);
    }
    int32_t _reg0 = _if<_args & 1>::_val(_select<_popcount<_args & 0>::_result >::_apply(_0, _1, _2, _3, _4, _5, _6, _7, _8, _9, _10, _11, _12, _13, _14, _15, _16, _17, _18, _19, _20));
    int32_t _reg1 = _if<_args & 2>::_val(_select<_popcount<_args & 1>::_result >::_apply(_0, _1, _2, _3, _4, _5, _6, _7, _8, _9, _10, _11, _12, _13, _14, _15, _16, _17, _18, _19, _20));
    int32_t _reg2 = _if<_args & 4>::_val(_select<_popcount<_args & 3>::_result >::_apply(_0, _1, _2, _3, _4, _5, _6, _7, _8, _9, _10, _11, _12, _13, _14, _15, _16, _17, _18, _19, _20));
    int32_t _reg3 = _if<_args & 8>::_val(_select<_popcount<_args & 7>::_result >::_apply(_0, _1, _2, _3, _4, _5, _6, _7, _8, _9, _10, _11, _12, _13, _14, _15, _16, _17, _18, _19, _20));
    int32_t _reg4 = _if<_args & 16>::_val(_select<_popcount<_args & 15>::_result >::_apply(_0, _1, _2, _3, _4, _5, _6, _7, _8, _9, _10, _11, _12, _13, _14, _15, _16, _17, _18, _19, _20));
    int32_t _reg5 = _if<_args & 32>::_val(_select<_popcount<_args & 31>::_result >::_apply(_0, _1, _2, _3, _4, _5, _6, _7, _8, _9, _10, _11, _12, _13, _14, _15, _16, _17, _18, _19, _20));
    int32_t _reg6 = _if<_args & 64>::_val(_select<_popcount<_args & 63>::_result >::_apply(_0, _1, _2, _3, _4, _5, _6, _7, _8, _9, _10, _11, _12, _13, _14, _15, _16, _17, _18, _19, _20));
    int32_t _reg7 = _if<_args & 128>::_val(_select<_popcount<_args & 127>::_result >::_apply(_0, _1, _2, _3, _4, _5, _6, _7, _8, _9, _10, _11, _12, _13, _14, _15, _16, _17, _18, _19, _20));
    int32_t _reg8 = _if<_args & 256>::_val(_select<_popcount<_args & 255>::_result >::_apply(_0, _1, _2, _3, _4, _5, _6, _7, _8, _9, _10, _11, _12, _13, _14, _15, _16, _17, _18, _19, _20));
    int32_t _reg9 = _if<_args & 512>::_val(_select<_popcount<_args & 511>::_result >::_apply(_0, _1, _2, _3, _4, _5, _6, _7, _8, _9, _10, _11, _12, _13, _14, _15, _16, _17, _18, _19, _20));
    uint32_t _in_registers = _args & 0x3FF;
    if (_args & (1U << 11)) {
      uint32_t const _block_reg = (_args >> 12) & 0xF;
      if (_block_reg == 0) _reg0 = (uint32_t)_array;
      if (_block_reg == 1) _reg1 = (uint32_t)_array;
      if (_block_reg == 2) _reg2 = (uint32_t)_array;
      if (_block_reg == 3) _reg3 = (uint32_t)_array;
      if (_block_reg == 4) _reg4 = (uint32_t)_array;
      if (_block_reg == 5) _reg5 = (uint32_t)_array;
      if (_block_reg == 6) _reg6 = (uint32_t)_array;
      if (_block_reg == 7) _reg7 = (uint32_t)_array;
      if (_block_reg == 8) _reg8 = (uint32_t)_array;
      if (_block_reg == 9) _reg9 = (uint32_t)_array;
      _in_registers |= (1 << _block_reg);
    }
    uint32_t _reg10 = 0;
    if (_is_x) _swi_no |= (1U << 17); 
    _do_swi::_apply(_in_registers, _swi_no, _reg0, _reg1, _reg2, _reg3, _reg4, _reg5, _reg6, _reg7, _reg8, _reg9, _reg10);
    if (_is_x && (_reg10 & 0x10000000)) {
      return (_return_type)_reg0;
    }
    _if<_args & 2147483648U>::_set(_select<_popcount<_args & 1023U>::_result>::_apply(_0, _1, _2, _3, _4, _5, _6, _7, _8, _9, _10, _11, _12, _13, _14, _15, _16, _17, _18, _19, _20), _reg0);
    _if<_args & 1073741824U>::_set(_select<_popcount<_args & 2147484671U>::_result>::_apply(_0, _1, _2, _3, _4, _5, _6, _7, _8, _9, _10, _11, _12, _13, _14, _15, _16, _17, _18, _19, _20), _reg1);
    _if<_args & 536870912U>::_set(_select<_popcount<_args & 3221226495U>::_result>::_apply(_0, _1, _2, _3, _4, _5, _6, _7, _8, _9, _10, _11, _12, _13, _14, _15, _16, _17, _18, _19, _20), _reg2);
    _if<_args & 268435456U>::_set(_select<_popcount<_args & 3758097407U>::_result>::_apply(_0, _1, _2, _3, _4, _5, _6, _7, _8, _9, _10, _11, _12, _13, _14, _15, _16, _17, _18, _19, _20), _reg3);
    _if<_args & 134217728U>::_set(_select<_popcount<_args & 4026532863U>::_result>::_apply(_0, _1, _2, _3, _4, _5, _6, _7, _8, _9, _10, _11, _12, _13, _14, _15, _16, _17, _18, _19, _20), _reg4);
    _if<_args & 67108864U>::_set(_select<_popcount<_args & 4160750591U>::_result>::_apply(_0, _1, _2, _3, _4, _5, _6, _7, _8, _9, _10, _11, _12, _13, _14, _15, _16, _17, _18, _19, _20), _reg5);
    _if<_args & 33554432U>::_set(_select<_popcount<_args & 4227859455U>::_result>::_apply(_0, _1, _2, _3, _4, _5, _6, _7, _8, _9, _10, _11, _12, _13, _14, _15, _16, _17, _18, _19, _20), _reg6);
    _if<_args & 16777216U>::_set(_select<_popcount<_args & 4261413887U>::_result>::_apply(_0, _1, _2, _3, _4, _5, _6, _7, _8, _9, _10, _11, _12, _13, _14, _15, _16, _17, _18, _19, _20), _reg7);
    _if<_args & 8388608U>::_set(_select<_popcount<_args & 4278191103U>::_result>::_apply(_0, _1, _2, _3, _4, _5, _6, _7, _8, _9, _10, _11, _12, _13, _14, _15, _16, _17, _18, _19, _20), _reg8);
    _if<_args & 4194304U>::_set(_select<_popcount<_args & 4286579711U>::_result>::_apply(_0, _1, _2, _3, _4, _5, _6, _7, _8, _9, _10, _11, _12, _13, _14, _15, _16, _17, _18, _19, _20), _reg9);
    _if<_args & 2097152U>::_set(_select<_popcount<_args & 4290774015U>::_result>::_apply(_0, _1, _2, _3, _4, _5, _6, _7, _8, _9, _10, _11, _12, _13, _14, _15, _16, _17, _18, _19, _20), _reg10);
    if (_is_x) {
      return (_return_type)0;
    } else {
      return (_return_type)_select<(_args >> 16) & 0xF>::_apply(_reg0, _reg1, _reg2, _reg3, _reg4, _reg5, _reg6, _reg7, _reg8, _reg9, _reg10, 12, 13, 14, 15, 16, _reg10, 18, 19, 20, 21);
    }
  }

  static _return_type _apply(uint32_t const _swi_no) {
    return _apply2(_swi_no, _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type());
  }

  template <typename _0t> static _return_type _apply(uint32_t const _swi_no, _0t const& _0) {
    return _apply2(_swi_no, _0, _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type());
  }

  template <typename _0t, typename _1t> static _return_type _apply(uint32_t const _swi_no, _0t const& _0, _1t const& _1) {
    return _apply2(_swi_no, _0, _1, _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type());
  }

  template <typename _0t, typename _1t, typename _2t> static _return_type _apply(uint32_t const _swi_no, _0t const& _0, _1t const& _1, _2t const& _2) {
    return _apply2(_swi_no, _0, _1, _2, _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type());
  }

  template <typename _0t, typename _1t, typename _2t, typename _3t> static _return_type _apply(uint32_t const _swi_no, _0t const& _0, _1t const& _1, _2t const& _2, _3t const& _3) {
    return _apply2(_swi_no, _0, _1, _2, _3, _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type());
  }

  template <typename _0t, typename _1t, typename _2t, typename _3t, typename _4t> static _return_type _apply(uint32_t const _swi_no, _0t const& _0, _1t const& _1, _2t const& _2, _3t const& _3, _4t const& _4) {
    return _apply2(_swi_no, _0, _1, _2, _3, _4, _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type());
  }

  template <typename _0t, typename _1t, typename _2t, typename _3t, typename _4t, typename _5t> static _return_type _apply(uint32_t const _swi_no, _0t const& _0, _1t const& _1, _2t const& _2, _3t const& _3, _4t const& _4, _5t const& _5) {
    return _apply2(_swi_no, _0, _1, _2, _3, _4, _5, _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type());
  }

  template <typename _0t, typename _1t, typename _2t, typename _3t, typename _4t, typename _5t, typename _6t> static _return_type _apply(uint32_t const _swi_no, _0t const& _0, _1t const& _1, _2t const& _2, _3t const& _3, _4t const& _4, _5t const& _5, _6t const& _6) {
    return _apply2(_swi_no, _0, _1, _2, _3, _4, _5, _6, _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type());
  }

  template <typename _0t, typename _1t, typename _2t, typename _3t, typename _4t, typename _5t, typename _6t, typename _7t> static _return_type _apply(uint32_t const _swi_no, _0t const& _0, _1t const& _1, _2t const& _2, _3t const& _3, _4t const& _4, _5t const& _5, _6t const& _6, _7t const& _7) {
    return _apply2(_swi_no, _0, _1, _2, _3, _4, _5, _6, _7, _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type());
  }

  template <typename _0t, typename _1t, typename _2t, typename _3t, typename _4t, typename _5t, typename _6t, typename _7t, typename _8t> static _return_type _apply(uint32_t const _swi_no, _0t const& _0, _1t const& _1, _2t const& _2, _3t const& _3, _4t const& _4, _5t const& _5, _6t const& _6, _7t const& _7, _8t const& _8) {
    return _apply2(_swi_no, _0, _1, _2, _3, _4, _5, _6, _7, _8, _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type());
  }

  template <typename _0t, typename _1t, typename _2t, typename _3t, typename _4t, typename _5t, typename _6t, typename _7t, typename _8t, typename _9t> static _return_type _apply(uint32_t const _swi_no, _0t const& _0, _1t const& _1, _2t const& _2, _3t const& _3, _4t const& _4, _5t const& _5, _6t const& _6, _7t const& _7, _8t const& _8, _9t const& _9) {
    return _apply2(_swi_no, _0, _1, _2, _3, _4, _5, _6, _7, _8, _9, _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type());
  }

  template <typename _0t, typename _1t, typename _2t, typename _3t, typename _4t, typename _5t, typename _6t, typename _7t, typename _8t, typename _9t, typename _10t> static _return_type _apply(uint32_t const _swi_no, _0t const& _0, _1t const& _1, _2t const& _2, _3t const& _3, _4t const& _4, _5t const& _5, _6t const& _6, _7t const& _7, _8t const& _8, _9t const& _9, _10t const& _10) {
    return _apply2(_swi_no, _0, _1, _2, _3, _4, _5, _6, _7, _8, _9, _10, _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type());
  }

  template <typename _0t, typename _1t, typename _2t, typename _3t, typename _4t, typename _5t, typename _6t, typename _7t, typename _8t, typename _9t, typename _10t, typename _11t> static _return_type _apply(uint32_t const _swi_no, _0t const& _0, _1t const& _1, _2t const& _2, _3t const& _3, _4t const& _4, _5t const& _5, _6t const& _6, _7t const& _7, _8t const& _8, _9t const& _9, _10t const& _10, _11t const& _11) {
    return _apply2(_swi_no, _0, _1, _2, _3, _4, _5, _6, _7, _8, _9, _10, _11, _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type());
  }

  template <typename _0t, typename _1t, typename _2t, typename _3t, typename _4t, typename _5t, typename _6t, typename _7t, typename _8t, typename _9t, typename _10t, typename _11t, typename _12t> static _return_type _apply(uint32_t const _swi_no, _0t const& _0, _1t const& _1, _2t const& _2, _3t const& _3, _4t const& _4, _5t const& _5, _6t const& _6, _7t const& _7, _8t const& _8, _9t const& _9, _10t const& _10, _11t const& _11, _12t const& _12) {
    return _apply2(_swi_no, _0, _1, _2, _3, _4, _5, _6, _7, _8, _9, _10, _11, _12, _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type());
  }

  template <typename _0t, typename _1t, typename _2t, typename _3t, typename _4t, typename _5t, typename _6t, typename _7t, typename _8t, typename _9t, typename _10t, typename _11t, typename _12t, typename _13t> static _return_type _apply(uint32_t const _swi_no, _0t const& _0, _1t const& _1, _2t const& _2, _3t const& _3, _4t const& _4, _5t const& _5, _6t const& _6, _7t const& _7, _8t const& _8, _9t const& _9, _10t const& _10, _11t const& _11, _12t const& _12, _13t const& _13) {
    return _apply2(_swi_no, _0, _1, _2, _3, _4, _5, _6, _7, _8, _9, _10, _11, _12, _13, _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type());
  }

  template <typename _0t, typename _1t, typename _2t, typename _3t, typename _4t, typename _5t, typename _6t, typename _7t, typename _8t, typename _9t, typename _10t, typename _11t, typename _12t, typename _13t, typename _14t> static _return_type _apply(uint32_t const _swi_no, _0t const& _0, _1t const& _1, _2t const& _2, _3t const& _3, _4t const& _4, _5t const& _5, _6t const& _6, _7t const& _7, _8t const& _8, _9t const& _9, _10t const& _10, _11t const& _11, _12t const& _12, _13t const& _13, _14t const& _14) {
    return _apply2(_swi_no, _0, _1, _2, _3, _4, _5, _6, _7, _8, _9, _10, _11, _12, _13, _14, _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type());
  }

  template <typename _0t, typename _1t, typename _2t, typename _3t, typename _4t, typename _5t, typename _6t, typename _7t, typename _8t, typename _9t, typename _10t, typename _11t, typename _12t, typename _13t, typename _14t, typename _15t> static _return_type _apply(uint32_t const _swi_no, _0t const& _0, _1t const& _1, _2t const& _2, _3t const& _3, _4t const& _4, _5t const& _5, _6t const& _6, _7t const& _7, _8t const& _8, _9t const& _9, _10t const& _10, _11t const& _11, _12t const& _12, _13t const& _13, _14t const& _14, _15t const& _15) {
    return _apply2(_swi_no, _0, _1, _2, _3, _4, _5, _6, _7, _8, _9, _10, _11, _12, _13, _14, _15, _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type());
  }

  template <typename _0t, typename _1t, typename _2t, typename _3t, typename _4t, typename _5t, typename _6t, typename _7t, typename _8t, typename _9t, typename _10t, typename _11t, typename _12t, typename _13t, typename _14t, typename _15t, typename _16t> static _return_type _apply(uint32_t const _swi_no, _0t const& _0, _1t const& _1, _2t const& _2, _3t const& _3, _4t const& _4, _5t const& _5, _6t const& _6, _7t const& _7, _8t const& _8, _9t const& _9, _10t const& _10, _11t const& _11, _12t const& _12, _13t const& _13, _14t const& _14, _15t const& _15, _16t const& _16) {
    return _apply2(_swi_no, _0, _1, _2, _3, _4, _5, _6, _7, _8, _9, _10, _11, _12, _13, _14, _15, _16, _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type());
  }

  template <typename _0t, typename _1t, typename _2t, typename _3t, typename _4t, typename _5t, typename _6t, typename _7t, typename _8t, typename _9t, typename _10t, typename _11t, typename _12t, typename _13t, typename _14t, typename _15t, typename _16t, typename _17t> static _return_type _apply(uint32_t const _swi_no, _0t const& _0, _1t const& _1, _2t const& _2, _3t const& _3, _4t const& _4, _5t const& _5, _6t const& _6, _7t const& _7, _8t const& _8, _9t const& _9, _10t const& _10, _11t const& _11, _12t const& _12, _13t const& _13, _14t const& _14, _15t const& _15, _16t const& _16, _17t const& _17) {
    return _apply2(_swi_no, _0, _1, _2, _3, _4, _5, _6, _7, _8, _9, _10, _11, _12, _13, _14, _15, _16, _17, _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type());
  }

  template <typename _0t, typename _1t, typename _2t, typename _3t, typename _4t, typename _5t, typename _6t, typename _7t, typename _8t, typename _9t, typename _10t, typename _11t, typename _12t, typename _13t, typename _14t, typename _15t, typename _16t, typename _17t, typename _18t> static _return_type _apply(uint32_t const _swi_no, _0t const& _0, _1t const& _1, _2t const& _2, _3t const& _3, _4t const& _4, _5t const& _5, _6t const& _6, _7t const& _7, _8t const& _8, _9t const& _9, _10t const& _10, _11t const& _11, _12t const& _12, _13t const& _13, _14t const& _14, _15t const& _15, _16t const& _16, _17t const& _17, _18t const& _18) {
    return _apply2(_swi_no, _0, _1, _2, _3, _4, _5, _6, _7, _8, _9, _10, _11, _12, _13, _14, _15, _16, _17, _18, _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type());
  }

  template <typename _0t, typename _1t, typename _2t, typename _3t, typename _4t, typename _5t, typename _6t, typename _7t, typename _8t, typename _9t, typename _10t, typename _11t, typename _12t, typename _13t, typename _14t, typename _15t, typename _16t, typename _17t, typename _18t, typename _19t> static _return_type _apply(uint32_t const _swi_no, _0t const& _0, _1t const& _1, _2t const& _2, _3t const& _3, _4t const& _4, _5t const& _5, _6t const& _6, _7t const& _7, _8t const& _8, _9t const& _9, _10t const& _10, _11t const& _11, _12t const& _12, _13t const& _13, _14t const& _14, _15t const& _15, _16t const& _16, _17t const& _17, _18t const& _18, _19t const& _19) {
    return _apply2(_swi_no, _0, _1, _2, _3, _4, _5, _6, _7, _8, _9, _10, _11, _12, _13, _14, _15, _16, _17, _18, _19, _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type());
  }

  template <typename _0t, typename _1t, typename _2t, typename _3t, typename _4t, typename _5t, typename _6t, typename _7t, typename _8t, typename _9t, typename _10t, typename _11t, typename _12t, typename _13t, typename _14t, typename _15t, typename _16t, typename _17t, typename _18t, typename _19t, typename _20t> static _return_type _apply(uint32_t const _swi_no, _0t const& _0, _1t const& _1, _2t const& _2, _3t const& _3, _4t const& _4, _5t const& _5, _6t const& _6, _7t const& _7, _8t const& _8, _9t const& _9, _10t const& _10, _11t const& _11, _12t const& _12, _13t const& _13, _14t const& _14, _15t const& _15, _16t const& _16, _17t const& _17, _18t const& _18, _19t const& _19, _20t const& _20) {
    return _apply2(_swi_no, _0, _1, _2, _3, _4, _5, _6, _7, _8, _9, _10, _11, _12, _13, _14, _15, _16, _17, _18, _19, _20, _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type());
  }

  template <typename _0t, typename _1t, typename _2t, typename _3t, typename _4t, typename _5t, typename _6t, typename _7t, typename _8t, typename _9t, typename _10t, typename _11t, typename _12t, typename _13t, typename _14t, typename _15t, typename _16t, typename _17t, typename _18t, typename _19t, typename _20t, typename _21t> static _return_type _apply(uint32_t const _swi_no, _0t const& _0, _1t const& _1, _2t const& _2, _3t const& _3, _4t const& _4, _5t const& _5, _6t const& _6, _7t const& _7, _8t const& _8, _9t const& _9, _10t const& _10, _11t const& _11, _12t const& _12, _13t const& _13, _14t const& _14, _15t const& _15, _16t const& _16, _17t const& _17, _18t const& _18, _19t const& _19, _20t const& _20, _21t const& _21) {
    return _apply2(_swi_no, _0, _1, _2, _3, _4, _5, _6, _7, _8, _9, _10, _11, _12, _13, _14, _15, _16, _17, _18, _19, _20, _21, _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type());
  }

  template <typename _0t, typename _1t, typename _2t, typename _3t, typename _4t, typename _5t, typename _6t, typename _7t, typename _8t, typename _9t, typename _10t, typename _11t, typename _12t, typename _13t, typename _14t, typename _15t, typename _16t, typename _17t, typename _18t, typename _19t, typename _20t, typename _21t, typename _22t> static _return_type _apply(uint32_t const _swi_no, _0t const& _0, _1t const& _1, _2t const& _2, _3t const& _3, _4t const& _4, _5t const& _5, _6t const& _6, _7t const& _7, _8t const& _8, _9t const& _9, _10t const& _10, _11t const& _11, _12t const& _12, _13t const& _13, _14t const& _14, _15t const& _15, _16t const& _16, _17t const& _17, _18t const& _18, _19t const& _19, _20t const& _20, _21t const& _21, _22t const& _22) {
    return _apply2(_swi_no, _0, _1, _2, _3, _4, _5, _6, _7, _8, _9, _10, _11, _12, _13, _14, _15, _16, _17, _18, _19, _20, _21, _22, _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type());
  }

  template <typename _0t, typename _1t, typename _2t, typename _3t, typename _4t, typename _5t, typename _6t, typename _7t, typename _8t, typename _9t, typename _10t, typename _11t, typename _12t, typename _13t, typename _14t, typename _15t, typename _16t, typename _17t, typename _18t, typename _19t, typename _20t, typename _21t, typename _22t, typename _23t> static _return_type _apply(uint32_t const _swi_no, _0t const& _0, _1t const& _1, _2t const& _2, _3t const& _3, _4t const& _4, _5t const& _5, _6t const& _6, _7t const& _7, _8t const& _8, _9t const& _9, _10t const& _10, _11t const& _11, _12t const& _12, _13t const& _13, _14t const& _14, _15t const& _15, _16t const& _16, _17t const& _17, _18t const& _18, _19t const& _19, _20t const& _20, _21t const& _21, _22t const& _22, _23t const& _23) {
    return _apply2(_swi_no, _0, _1, _2, _3, _4, _5, _6, _7, _8, _9, _10, _11, _12, _13, _14, _15, _16, _17, _18, _19, _20, _21, _22, _23, _null_type(), _null_type(), _null_type(), _null_type(), _null_type(), _null_type());
  }

  template <typename _0t, typename _1t, typename _2t, typename _3t, typename _4t, typename _5t, typename _6t, typename _7t, typename _8t, typename _9t, typename _10t, typename _11t, typename _12t, typename _13t, typename _14t, typename _15t, typename _16t, typename _17t, typename _18t, typename _19t, typename _20t, typename _21t, typename _22t, typename _23t, typename _24t> static _return_type _apply(uint32_t const _swi_no, _0t const& _0, _1t const& _1, _2t const& _2, _3t const& _3, _4t const& _4, _5t const& _5, _6t const& _6, _7t const& _7, _8t const& _8, _9t const& _9, _10t const& _10, _11t const& _11, _12t const& _12, _13t const& _13, _14t const& _14, _15t const& _15, _16t const& _16, _17t const& _17, _18t const& _18, _19t const& _19, _20t const& _20, _21t const& _21, _22t const& _22, _23t const& _23, _24t const& _24) {
    return _apply2(_swi_no, _0, _1, _2, _3, _4, _5, _6, _7, _8, _9, _10, _11, _12, _13, _14, _15, _16, _17, _18, _19, _20, _21, _22, _23, _24, _null_type(), _null_type(), _null_type(), _null_type(), _null_type());
  }

  template <typename _0t, typename _1t, typename _2t, typename _3t, typename _4t, typename _5t, typename _6t, typename _7t, typename _8t, typename _9t, typename _10t, typename _11t, typename _12t, typename _13t, typename _14t, typename _15t, typename _16t, typename _17t, typename _18t, typename _19t, typename _20t, typename _21t, typename _22t, typename _23t, typename _24t, typename _25t> static _return_type _apply(uint32_t const _swi_no, _0t const& _0, _1t const& _1, _2t const& _2, _3t const& _3, _4t const& _4, _5t const& _5, _6t const& _6, _7t const& _7, _8t const& _8, _9t const& _9, _10t const& _10, _11t const& _11, _12t const& _12, _13t const& _13, _14t const& _14, _15t const& _15, _16t const& _16, _17t const& _17, _18t const& _18, _19t const& _19, _20t const& _20, _21t const& _21, _22t const& _22, _23t const& _23, _24t const& _24, _25t const& _25) {
    return _apply2(_swi_no, _0, _1, _2, _3, _4, _5, _6, _7, _8, _9, _10, _11, _12, _13, _14, _15, _16, _17, _18, _19, _20, _21, _22, _23, _24, _25, _null_type(), _null_type(), _null_type(), _null_type());
  }

  template <typename _0t, typename _1t, typename _2t, typename _3t, typename _4t, typename _5t, typename _6t, typename _7t, typename _8t, typename _9t, typename _10t, typename _11t, typename _12t, typename _13t, typename _14t, typename _15t, typename _16t, typename _17t, typename _18t, typename _19t, typename _20t, typename _21t, typename _22t, typename _23t, typename _24t, typename _25t, typename _26t> static _return_type _apply(uint32_t const _swi_no, _0t const& _0, _1t const& _1, _2t const& _2, _3t const& _3, _4t const& _4, _5t const& _5, _6t const& _6, _7t const& _7, _8t const& _8, _9t const& _9, _10t const& _10, _11t const& _11, _12t const& _12, _13t const& _13, _14t const& _14, _15t const& _15, _16t const& _16, _17t const& _17, _18t const& _18, _19t const& _19, _20t const& _20, _21t const& _21, _22t const& _22, _23t const& _23, _24t const& _24, _25t const& _25, _26t const& _26) {
    return _apply2(_swi_no, _0, _1, _2, _3, _4, _5, _6, _7, _8, _9, _10, _11, _12, _13, _14, _15, _16, _17, _18, _19, _20, _21, _22, _23, _24, _25, _26, _null_type(), _null_type(), _null_type());
  }

  template <typename _0t, typename _1t, typename _2t, typename _3t, typename _4t, typename _5t, typename _6t, typename _7t, typename _8t, typename _9t, typename _10t, typename _11t, typename _12t, typename _13t, typename _14t, typename _15t, typename _16t, typename _17t, typename _18t, typename _19t, typename _20t, typename _21t, typename _22t, typename _23t, typename _24t, typename _25t, typename _26t, typename _27t> static _return_type _apply(uint32_t const _swi_no, _0t const& _0, _1t const& _1, _2t const& _2, _3t const& _3, _4t const& _4, _5t const& _5, _6t const& _6, _7t const& _7, _8t const& _8, _9t const& _9, _10t const& _10, _11t const& _11, _12t const& _12, _13t const& _13, _14t const& _14, _15t const& _15, _16t const& _16, _17t const& _17, _18t const& _18, _19t const& _19, _20t const& _20, _21t const& _21, _22t const& _22, _23t const& _23, _24t const& _24, _25t const& _25, _26t const& _26, _27t const& _27) {
    return _apply2(_swi_no, _0, _1, _2, _3, _4, _5, _6, _7, _8, _9, _10, _11, _12, _13, _14, _15, _16, _17, _18, _19, _20, _21, _22, _23, _24, _25, _26, _27, _null_type(), _null_type());
  }

  template <typename _0t, typename _1t, typename _2t, typename _3t, typename _4t, typename _5t, typename _6t, typename _7t, typename _8t, typename _9t, typename _10t, typename _11t, typename _12t, typename _13t, typename _14t, typename _15t, typename _16t, typename _17t, typename _18t, typename _19t, typename _20t, typename _21t, typename _22t, typename _23t, typename _24t, typename _25t, typename _26t, typename _27t, typename _28t> static _return_type _apply(uint32_t const _swi_no, _0t const& _0, _1t const& _1, _2t const& _2, _3t const& _3, _4t const& _4, _5t const& _5, _6t const& _6, _7t const& _7, _8t const& _8, _9t const& _9, _10t const& _10, _11t const& _11, _12t const& _12, _13t const& _13, _14t const& _14, _15t const& _15, _16t const& _16, _17t const& _17, _18t const& _18, _19t const& _19, _20t const& _20, _21t const& _21, _22t const& _22, _23t const& _23, _24t const& _24, _25t const& _25, _26t const& _26, _27t const& _27, _28t const& _28) {
    return _apply2(_swi_no, _0, _1, _2, _3, _4, _5, _6, _7, _8, _9, _10, _11, _12, _13, _14, _15, _16, _17, _18, _19, _20, _21, _22, _23, _24, _25, _26, _27, _28, _null_type());
  }

  template <typename _0t, typename _1t, typename _2t, typename _3t, typename _4t, typename _5t, typename _6t, typename _7t, typename _8t, typename _9t, typename _10t, typename _11t, typename _12t, typename _13t, typename _14t, typename _15t, typename _16t, typename _17t, typename _18t, typename _19t, typename _20t, typename _21t, typename _22t, typename _23t, typename _24t, typename _25t, typename _26t, typename _27t, typename _28t, typename _29t> static _return_type _apply(uint32_t const _swi_no, _0t const& _0, _1t const& _1, _2t const& _2, _3t const& _3, _4t const& _4, _5t const& _5, _6t const& _6, _7t const& _7, _8t const& _8, _9t const& _9, _10t const& _10, _11t const& _11, _12t const& _12, _13t const& _13, _14t const& _14, _15t const& _15, _16t const& _16, _17t const& _17, _18t const& _18, _19t const& _19, _20t const& _20, _21t const& _21, _22t const& _22, _23t const& _23, _24t const& _24, _25t const& _25, _26t const& _26, _27t const& _27, _28t const& _28, _29t const& _29) {
    return _apply2(_swi_no, _0, _1, _2, _3, _4, _5, _6, _7, _8, _9, _10, _11, _12, _13, _14, _15, _16, _17, _18, _19, _20, _21, _22, _23, _24, _25, _26, _27, _28, _29);
  }

};
}

#define _swi(_swi_no, _args, ...) (::_swi_ns::_imp<_SWI_OPTIMIZE && __builtin_constant_p(_swi_no) ? true : false, false, (_args)>::_apply(uint32_t(_swi_no), ## __VA_ARGS__))
#define _swix(_swi_no, _args, ...) (::_swi_ns::_imp<_SWI_OPTIMIZE && __builtin_constant_p(_swi_no) ? true : false, true, (_args)>::_apply(uint32_t(_swi_no), ## __VA_ARGS__))

#endif
