#!/usr/bin/perl

my $max_params = 30;

print << "END";
// _swi++, call RISC OS SWIs from C++
// Copyright (C) 2008  Timothy Baldwin
// Version 1

// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU Lesser General Public License as published
// by the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.

// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

// http://www.majoroak.f2s.com/tim/RISC_OS/swipp/

END

my $prologue = << "END";
  static void _apply(uint32_t _in_registers, uint32_t _swi_no, int32_t& _p0, int32_t& _p1, int32_t& _p2, int32_t& _p3, int32_t& _p4, int32_t& _p5, int32_t& _p6, int32_t& _p7, int32_t& _p8, int32_t& _p9, uint32_t& _flags) {
    // Must not be a template due to gcc bug:
    // http://gcc.gnu.org/bugzilla/show_bug.cgi?id=33661
    register int32_t _reg0 __asm__("r0");
    if (_in_registers & 0x001) _reg0 = _p0;
    register int32_t _reg1 __asm__("r1");
    if (_in_registers & 0x002) _reg1 = _p1;
    register int32_t _reg2 __asm__("r2");
    if (_in_registers & 0x004) _reg2 = _p2;
    register int32_t _reg3 __asm__("r3");
    if (_in_registers & 0x008) _reg3 = _p3;
    register int32_t _reg4 __asm__("r4");
    if (_in_registers & 0x010) _reg4 = _p4;
    register int32_t _reg5 __asm__("r5");
    if (_in_registers & 0x020) _reg5 = _p5;
    register int32_t _reg6 __asm__("r6");
    if (_in_registers & 0x040) _reg6 = _p6;
    register int32_t _reg7 __asm__("r7");
    if (_in_registers & 0x080) _reg7 = _p7;
    register int32_t _reg8 __asm__("r8");
    if (_in_registers & 0x100) _reg8 = _p8;
    register int32_t _reg9 __asm__("r9");
    if (_in_registers & 0x200) _reg9 = _p9;
END

my $epilogue = << "END";
    _p0 = _reg0;
    _p1 = _reg1;
    _p2 = _reg2;
    _p3 = _reg3;
    _p4 = _reg4;
    _p5 = _reg5;
    _p6 = _reg6;
    _p7 = _reg7;
    _p8 = _reg8;
    _p9 = _reg9;
  }
END

print << "END";
// This file is automatically generated - do not edit.

#ifndef _swipp_H
#define _swipp_H

#include <stdint.h>
#include <swis.h>

#if defined(__OPTIMIZE__) && __OPTIMIZE__
#define _SWI_OPTIMIZE 1
#else
#define _SWI_OPTIMIZE 0
#endif

// Define _SWI_USR_MODE for a little better performance in USR 
// mode, at the cost of an incompatability with SVC mode.
#if defined(_SWI_USR_MODE) && _SWI_USR_MODE
#define _SWI_CLOBBERS "memory", "cc"
#else
#define _SWI_CLOBBERS "memory", "cc", "lr"
#endif

namespace _swi_ns {

struct _do_swi_const {
$prologue
    __asm__ volatile ("swi\\t%[_swi_n]" : "+r" (_reg0), "+r" (_reg1), "+r" (_reg2), "+r" (_reg3), "+r" (_reg4), "+r" (_reg5), "+r" (_reg6), "+r" (_reg7), "+r" (_reg8), "+r" (_reg9) : [_swi_n] "i" (_swi_no) : _SWI_CLOBBERS);
$epilogue
};

struct _do_swi_var {
$prologue
    register uint32_t _reg12 __asm__("r12") = _swi_no;
    __asm__ volatile ("swi\\t0x71" : "+r" (_reg0), "+r" (_reg1), "+r" (_reg2), "+r" (_reg3), "+r" (_reg4), "+r" (_reg5), "+r" (_reg6), "+r" (_reg7), "+r" (_reg8), "+r" (_reg9) : "r" (_reg12) : _SWI_CLOBBERS);
$epilogue
};

struct _do_swi_const_flags {
$prologue
    __asm__ volatile ("swi\\t%[_swi_n]\\n\\teor\\t%[_cpsr], r15, r15\\n\\tmsr\\t%[_cpsr], cpsr" : "+r" (_reg0), "+r" (_reg1), "+r" (_reg2), "+r" (_reg3), "+r" (_reg4), "+r" (_reg5), "+r" (_reg6), "+r" (_reg7), "+r" (_reg8), "+r" (_reg9), [_cpsr] "=r" (_flags) : [_swi_n] "i" (_swi_no) : _SWI_CLOBBERS);
$epilogue
};

struct _do_swi_var_flags {
$prologue
    register uint32_t _reg12 __asm__("r12") = _swi_no;
    __asm__ volatile ("swi\\t0x71\\n\\teor\\t%[_cpsr], r15, r15\\n\\tmsr\\t%[_cpsr], cpsr" : "+r" (_reg0), "+r" (_reg1), "+r" (_reg2), "+r" (_reg3), "+r" (_reg4), "+r" (_reg5), "+r" (_reg6), "+r" (_reg7), "+r" (_reg8), "+r" (_reg9), [_cpsr] "=r" (_flags) : "r" (_reg12) : _SWI_CLOBBERS);
$epilogue
};

#undef _SWI_CLOBBERS

template <bool _is_const, bool _need_flags> struct _do_swi_select {};

template <> struct _do_swi_select<false, false> {
  typedef _do_swi_var _do_swi;
};

template <> struct _do_swi_select<true, false> {
  typedef _do_swi_const _do_swi;
};

template <> struct _do_swi_select<false, true> {
  typedef _do_swi_var_flags _do_swi;
};

template <> struct _do_swi_select<true, true> {
  typedef _do_swi_const_flags _do_swi;
};


// Recursive compile-time bit count.
template <unsigned _p> struct _popcount {
  static const unsigned _result = (_p & 1) + _popcount<(_p >> 1)>::_result;
};

template <> struct _popcount<0> {
  static const unsigned _result = 0;
};

struct _null_type { 
  int _dummy[0]; 
  template <typename _t> void operator = (_t const & _dummy) {}
};





template <bool _bool_value> struct _if {
  typedef int32_t _return_type;
  template <typename _t> static int32_t _val(_t _v) { return 0; }
  template <typename _t> static void _set(_t const &_v, int32_t _r) {}
  template <typename _t> static void _set_block(char *_ptr, _t const & _val) {}
};

template <> struct _if<true> {
  typedef _kernel_oserror* _return_type;

  // Write an _OUT() parameter.
  template <typename _t> static void _set(_t const & _v, uint32_t _r) { *_v = _r; }

  // Refuse to handle _null_type, long long, and unsigned long long as _IN() parameters.
  static _null_type _val(_null_type _v) { return _null_type(); }
  static _null_type _val(long long _v) { return _null_type(); }
  static _null_type _val(unsigned long long _v) { return _null_type(); }

  // Generic reading of _IN() parameters.
  template <typename _t> static int32_t _val(_t * _v) { return (uint32_t)_v; }
  template <typename _t> static int32_t _val(_t const * _v) { return (uint32_t)_v; }
  template <typename _t> static int32_t _val(_t const & _v) { return static_cast<int32_t>(_v); }

  // Ignore _null_type _BLOCK() parameters.
  static void _set_block(char *_ptr, _null_type const & _val) {}

  // Generic handling of _BLOCK() parameters.
  template <typename _t> static void _set_block(char *_ptr, _t const & _val) { *( _t *)_ptr = _val; }

  // Including arrays.
  template <typename _t> static void _set_block(char *_ptr, _t const _val[]) { *( _t const **)_ptr = _val; }

  // Special cases for built-in types.
  static void _set_block(char *_ptr, char _val) { *(int32_t *)_ptr = _val; }
  static void _set_block(char *_ptr, signed char _val) { *(int32_t *)_ptr = _val; }
  static void _set_block(char *_ptr, unsigned char _val) { *(int32_t *)_ptr = _val; }
  static void _set_block(char *_ptr, short _val) { *(int32_t *)_ptr = _val; }
  static void _set_block(char *_ptr, unsigned short _val) { *(int32_t *)_ptr = _val; }
  static void _set_block(char *_ptr, int _val) { *(int32_t *)_ptr = _val; }
  static void _set_block(char *_ptr, unsigned int _val) { *(uint32_t *)_ptr = _val; }

  // This seems to cause GCC to run out of registers. Why?
  static void _set_block(char *_ptr, long long _val) { *(int64_t *)_ptr = _val; }
  static void _set_block(char *_ptr, unsigned long long _val) { *(uint64_t *)_ptr = _val; }

};

// Generic handling of _BLOCK() parameters.
template <typename _t> struct _sizeof {
  static unsigned const _result = (sizeof(_t) + 3U) & ~3U;
};

// Including arrays.
template <typename _t> struct _sizeof<_t []> { static unsigned const _result = 4; };
template <typename _t> struct _sizeof<_t const []> { static unsigned const _result = 4; };

// Ignore _null_type _BLOCK() parameters.
template <> struct _sizeof<_null_type> { static unsigned const _result = 0; };

// Special cases for long long.
template <> struct _sizeof<long long> { static unsigned const _result = 8; };
template <> struct _sizeof<unsigned long long> { static unsigned const _result = 8; };


// Return the n-th argument.
template <unsigned _n> struct _select {};

END

sub repeat {
  my ($n, $s) = @_;
  for(my $i = 0; $i < $n; ++$i) {
    my $r = $s;
    $r =~ s/X/$i/g;
    print $r;
    if ($i != $n - 1) { print ", " }
  }
}


for (my $i = 0; $i < 21; ++$i) {
  print "template <> struct _select<${i}> { template <";
  repeat 21, "typename _Xt";
  print "> static _${i}t _apply(";
  repeat 21, "_Xt _X";
  print ") { return _${i}; } };\n\n";
}



print  << "END";
template <bool _is_const, bool _is_x, uint32_t _args> struct _imp {
  typedef typename _if<_is_x>::_return_type _return_type;
  typedef typename _do_swi_select<_is_const, _is_x || ((_args >> 21) > 9) || (_args & (1 << 21)) >::_do_swi _do_swi;

END
print "  template <";
repeat $max_params, "typename _Xt";
print "> static _return_type _apply2(uint32_t _swi_no, ";
repeat $max_params, "_Xt const& _X";
print  << "END";
) {
    int const _block = _popcount<_args & 0xFE00003F>::_result;
    char _array[0
END
for (my $i = 0; $i < $max_params; ++$i) {
  print "     + ($i >= _block ? _sizeof<_${i}t>::_result : 0)\n";
}
print  << "END";
    ] __attribute__((__aligned__(4)));
    if (_args & (1U << 11)) {
      char *_ptr2 = _array;
END
for (my $i = 0; $i < $max_params; ++$i) {
  print  << "END";
      _if<$i >= _block>::_set_block(_ptr2, _$i);
      _ptr2 += ($i >= _block ? _sizeof<_${i}t>::_result : 0);
END
}
print "    }\n";
my $k = 0;
for (my $i = 0; $i < 10; ++$i) {
  my $j = 1 << $i; 
  print "    int32_t _reg$i = _if<_args & $j>::_val(_select<_popcount<_args & $k>::_result >::_apply(_0, _1, _2, _3, _4, _5, _6, _7, _8, _9, _10, _11, _12, _13, _14, _15, _16, _17, _18, _19, _20));\n";
  $k = $k | $j;
}
print  << "END";
    uint32_t _in_registers = _args & 0x3FF;
    if (_args & (1U << 11)) {
      uint32_t const _block_reg = (_args >> 12) & 0xF;
END

for (my $i = 0; $i < 10; ++$i) {
  print "      if (_block_reg == $i) _reg$i = (uint32_t)_array;\n";
}
print  << "END";
      _in_registers |= (1 << _block_reg);
    }
    uint32_t _reg10 = 0;
    if (_is_x) _swi_no |= (1U << 17); 
    _do_swi::_apply(_in_registers, _swi_no, _reg0, _reg1, _reg2, _reg3, _reg4, _reg5, _reg6, _reg7, _reg8, _reg9, _reg10);
    if (_is_x && (_reg10 & 0x10000000)) {
      return (_return_type)_reg0;
    }
END
for (my $i = 0; $i < 11; ++$i) {
  my $j = 1 << (31 - $i); 
  print "    _if<_args & ${j}U>::_set(_select<_popcount<_args & ${k}U>::_result>::_apply(_0, _1, _2, _3, _4, _5, _6, _7, _8, _9, _10, _11, _12, _13, _14, _15, _16, _17, _18, _19, _20), _reg$i);\n";
 $k = $k | $j;
}
print  << "END";
    if (_is_x) {
      return (_return_type)0;
    } else {
      return (_return_type)_select<(_args >> 16) & 0xF>::_apply(_reg0, _reg1, _reg2, _reg3, _reg4, _reg5, _reg6, _reg7, _reg8, _reg9, _reg10, 12, 13, 14, 15, 16, _reg10, 18, 19, 20, 21);
    }
  }

END

for (my $i = 0; $i < $max_params + 1; ++$i) {
  print "  ";
  if ($i != 0) { 
    print "template <";
    repeat $i, "typename _Xt";
    print "> ";
  }
  print "static _return_type _apply(uint32_t const _swi_no";
  if ($i != 0) { print ", "; }
  repeat $i, "_Xt const& _X";
  print ") {\n    return _apply2(_swi_no, ";
  repeat $i, "_X";
  if ($i != 0 && $i != $max_params) { print ", "; }
  repeat $max_params - $i, "_null_type()";
  print ");\n  }\n\n";
}

print << "END";
};
}

#define _swi(_swi_no, _args, ...) (::_swi_ns::_imp<_SWI_OPTIMIZE && __builtin_constant_p(_swi_no) ? true : false, false, (_args)>::_apply(uint32_t(_swi_no), ## __VA_ARGS__))
#define _swix(_swi_no, _args, ...) (::_swi_ns::_imp<_SWI_OPTIMIZE && __builtin_constant_p(_swi_no) ? true : false, true, (_args)>::_apply(uint32_t(_swi_no), ## __VA_ARGS__))

#endif
END
